// Simple example of using memcopy to output (to a given file)
// a string preceeded by a length field.

#include <iostream>
#include <fstream>
using namespace std;

int main(int argc, char** argv) {

  if (argc != 2) {
    cout << "Usage: simple <outfile>.\n";
    exit(-1);
  }

  ofstream myFile(argv[1], ios::trunc | ios::out | ios::binary );
  char* string = "Hello, World!";
  cout << "String length is: " << strlen(string) << endl;
  int msglength = strlen(string) + 4 + 1;
  char* buff = new char[msglength];

  memcpy(buff, &msglength, 4); // Copy the length
  strcpy(&(buff[4]), string);

  myFile.write(buff, msglength);
  myFile.close();
  exit(0);
}
